with Reps, Scalars, Scalars.IO, Vectors, Vectors.Num, Taylors, Taylors.IO,Ada.Text_IO;
use Reps,Ada.Text_IO;

generic

   PDeg: in Natural;
   CutOff: in Natural;
   with package Numbers is new Scalars (<>);
   with package Numbers_IO is new Numbers.IO (<>);

package Doubling is

   use Numbers, Numbers_IO;

   package Tay is new Taylors (PDeg => PDeg,CutOff=>CutOff, Numbers => Numbers);
   package Tay_IO is new Tay.IO (Numbers_IO => Numbers_IO);
   use Tay;

  function Alpha(Y,X,Eps: in Scalar) return Scalar;
  function Beta(Y,X,Eps: in Scalar) return Scalar;
  function Gamma(Y: in Scalar) return Scalar;
  function LL(Y,X,Eps: in Scalar) return Scalar;
  function RR(Y,X,Eps: in Scalar) return Scalar;
  function T(Y,X,Eps,Z: in Scalar) return Scalar;
  function TI(Y,X,Eps,Z: in Scalar) return Scalar;
  function RI2(T,S: in Scalar) return Scalar;
  function LI2(T,S: in Scalar) return Scalar;
  function RI3(T,S: in Scalar) return Scalar;
  function LI3(T,S: in Scalar) return Scalar;
  function Zeta(Z: in Scalar) return Scalar;
  function ZetaI(Z: in Scalar) return Scalar;
  procedure ZetaI(Z1,Z2: in out Scalar);
  function Sigma1(Z: in Scalar) return Scalar;
  function Sigma1I(Z: in Scalar) return Scalar;
  procedure Sigma1I(Z1,Z2: in out Scalar);
  function Q1(Z: in Scalar) return Scalar;
  function Q1I(Z: in Scalar) return Scalar;
  procedure Q1I(Z1,Z2: in out Scalar);
  function M1(Z: in Scalar) return Scalar;
  function M1I(Z: in Scalar) return Scalar;
  procedure M1I(Z1,Z2: in out Scalar);
  function Theta1(Z: in Scalar) return Scalar;
  function Phi1(Z: in Scalar) return Scalar;
  procedure Phi1(Z1,Z2: in out Scalar);
  function Zeta2(Z,T,S: in Scalar) return Scalar;
  function Zeta2I(Z,T,S: in Scalar) return Scalar;
  function Sigma2(Z: in Scalar) return Scalar;
  function Sigma2I(Z: in Scalar) return Scalar;
  function Q2(Z,T,S: in Scalar) return Scalar;
  function Q2I(Z,T,S: in Scalar) return Scalar;
  function M2(Z,T,S: in Scalar) return Scalar;
  function M2I(Z,T,S: in Scalar) return Scalar;
  function Thet2(Z,T,S: in Scalar) return Scalar;
  function Ph2(Z,T,S: in Scalar) return Scalar;
  function Lin2I(Z,T,S: in Scalar) return Scalar;
  function Lin2(Z,T,S: in Scalar) return Scalar;
  function Theta2(Z,T,S: in Scalar) return Scalar;
  ------------------------------------------------
  procedure Zeta2(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Sigma2(Z1,Z2: in out Scalar);
  procedure Q2(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure M2(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Thet2(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Lin2(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Theta2(Z1,Z2: in out Scalar; T,S: in Scalar);
  ------------------------------------------------
  function Phi2(Z,T,S: in Scalar) return Scalar;
  function Zeta3(Z,T,S: in Scalar) return Scalar;
  function Zeta3I(Z,T,S: in Scalar) return Scalar;
  function Sigma3(Z: in Scalar) return Scalar;
  function Sigma3I(Z: in Scalar) return Scalar;
  function Q3(Z,T,S: in Scalar) return Scalar;
  function Q3I(Z,T,S: in Scalar) return Scalar;
  function M3(Z,T,S: in Scalar) return Scalar;
  function M3I(Z,T,S: in Scalar) return Scalar;
  function Thet3(Z,T,S: in Scalar) return Scalar;
  function Ph3(Z,T,S: in Scalar) return Scalar;
  function Lin3(Z,T,S: in Scalar) return Scalar;
  function Lin3I(Z,T,S: in Scalar) return Scalar;
  function Theta3(Z,T,S: in Scalar) return Scalar;
  ----------------------------------------------
  procedure Zeta3(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Sigma3(Z1,Z2: in out Scalar);
  procedure Q3(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure M3(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Thet3(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Lin3(Z1,Z2: in out Scalar; T,S: in Scalar);
  procedure Theta3(Z1,Z2: in out Scalar; T,S: in Scalar);
  ------------------------------------------------

  function Phi3(Z,T,S: in Scalar) return Scalar;
  function DerZeta1(Z: in Scalar) return Scalar;
  function DerZeta1I(Z: in Scalar) return Scalar;
  function DerSigma1(Z: in Scalar) return Scalar;
  function DerSigma1I(Z: in Scalar) return Scalar;
  function DerM1(Z: in Scalar) return Scalar;
  function DerM1I(Z: in Scalar) return Scalar;
  function DerQ1(Z: in Scalar) return Scalar;
  function DerQ1I(Z: in Scalar) return Scalar;
  function DerPhi1(Z: in Scalar) return Scalar;
  function DerZeta2(Z,T,S: in Scalar) return Scalar;
  function DerZeta2I(Z,T,S: in Scalar) return Scalar;
  function DerSigma2(Z: in Scalar) return Scalar;
  function DerSigma2I(Z: in Scalar) return Scalar;
  function DerM2(Z,T,S: in Scalar) return Scalar;
  function DerM2I(Z,T,S: in Scalar) return Scalar;
  function DerQ2(Z,T,S: in Scalar) return Scalar;
  function DerQ2I(Z,T,S: in Scalar) return Scalar;
  function DerLin2(Z,T,S: in Scalar) return Scalar;
  function DerLin2I(Z,T,S: in Scalar) return Scalar;
  function DerTheta2(Z,T,S: in Scalar) return Scalar;
  function DerZeta3(Z,T,S: in Scalar) return Scalar;
  function DerZeta3I(Z,T,S: in Scalar) return Scalar;
  function DerSigma3(Z: in Scalar) return Scalar;
  function DerSigma3I(Z: in Scalar) return Scalar;
  function DerM3(Z,T,S: in Scalar) return Scalar;
  function DerM3I(Z,T,S: in Scalar) return Scalar;
  function DerQ3(Z,T,S: in Scalar) return Scalar;
  function DerQ3I(Z,T,S: in Scalar) return Scalar;
  function DerLin3(Z,T,S: in Scalar) return Scalar;
  function DerLin3I(Z,T,S: in Scalar) return Scalar;
  function DerTheta3(Z,T,S: in Scalar) return Scalar;
  function T2(T,S: in Scalar) return Scalar;
  function T3(T,S: in Scalar) return Scalar;
  function S2(T,S: in Scalar) return Scalar;
  function S3(T,S: in Scalar) return Scalar;
  function Z2(T,S: in Scalar) return Scalar;
  function Z3(T,S: in Scalar) return Scalar;
  function X2(T,S: in Scalar) return Scalar;
  function X3(T,S: in Scalar) return Scalar;
  function U12(Z,T,S: in Scalar) return Scalar;
  function U13(Z,T,S: in Scalar) return Scalar;
  function U32(Z,T,S: in Scalar) return Scalar;
  function U33(Z,T,S: in Scalar) return Scalar;
  function L32(Z,T,S: in Scalar) return Scalar;
  function L33(Z,T,S: in Scalar) return Scalar;
  function L12(Z,T,S: in Scalar) return Scalar;
  function L13(Z,T,S: in Scalar) return Scalar;
  function MS2(T,S: in Scalar) return Scalar;
  function MZ2(T,S: in Scalar) return Scalar;
  function MS3(T,S: in Scalar) return Scalar;
  function MZ3(T,S: in Scalar) return Scalar;
  function MT2(T,S: in Scalar) return Scalar;
  function MD2(T,S: in Scalar) return Scalar;
  function MT3(T,S: in Scalar) return Scalar;
  function MD3(T,S: in Scalar) return Scalar;
  function XD2(T,S,Q: in Scalar) return Scalar;
  function XZ2(T,S,Q: in Scalar) return Scalar;
  function XT2(T,S,Q: in Scalar) return Scalar;
  function XS2(T,S,Q: in Scalar) return Scalar;
  function XD3(T,S,Q: in Scalar) return Scalar;
  function XZ3(T,S,Q: in Scalar) return Scalar;
  function XT3(T,S,Q: in Scalar) return Scalar;
  function XS3(T,S,Q: in Scalar) return Scalar;
  function NT2(T,S: in Scalar) return Scalar;
  function NS2(T,S: in Scalar) return Scalar;
  function ND2(T,S: in Scalar) return Scalar;
  function NZ2(T,S: in Scalar) return Scalar;
  function NT3(T,S: in Scalar) return Scalar;
  function NS3(T,S: in Scalar) return Scalar;
  function ND3(T,S: in Scalar) return Scalar;
  function NZ3(T,S: in Scalar) return Scalar;
  function U22(Z,T,S: in Scalar) return Scalar;
  function U23(Z,T,S: in Scalar) return Scalar;
  function L22(Z,T,S: in Scalar) return Scalar;
  function L23(Z,T,S: in Scalar) return Scalar;
  function Upp_2(Z,T,S: in Scalar) return Scalar;
  function Lou_2(Z,T,S: in Scalar) return Scalar;
  function Upp_3(Z,T,S: in Scalar) return Scalar;
  function Lou_3(Z,T,S: in Scalar) return Scalar;

  function Upp2(Z,T,S: in Scalar) return Scalar;
  function Lou2(Z,T,S: in Scalar) return Scalar;
  function Upp3(Z,T,S: in Scalar) return Scalar;
  function Lou3(Z,T,S: in Scalar) return Scalar;

  function Upp(Z,T,S: in Scalar) return Scalar;
  function Lou(Z,T,S: in Scalar) return Scalar;



  function Func2(T,S: in Scalar) return Scalar;
  function Zed2(T: in Scalar) return Scalar;
  function Func3(T,S: in Scalar) return Scalar;
  function Zed3(T: in Scalar) return Scalar;

  function Funk2(T,S: in Scalar) return Scalar;
  function Cee2(T: in Scalar) return Scalar;
  function Funk3(T,S: in Scalar) return Scalar;
  function Cee3(T: in Scalar) return Scalar;

  function L_M(TT,S: in Scalar; Epsi: in Scalar:=Scal(Zero)) return Scalar;
  function L_P(TT,S: in Scalar; Epsi: in Scalar:=Scal(Zero)) return Scalar;
--  function LM(T,Smin,Smax: in Scalar; Epsi: in Scalar:=Scal(Zero)) return Scalar;
--  function NewT(Y,X,T,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;

  function Corner_23 return Scalar;
  function Corner23 return Scalar;
  function Corner33 return Scalar;
  function Corner13(S: Scalar) return Scalar;

  function NewT(Y,X,T,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;

  function D2(Z,W,T,S: in Scalar) return Scalar;
  function D3(Z,W,T,S: in Scalar) return Scalar;
  function D22(Y,X,Z,Q,TT,S: in Scalar) return Scalar;
  function D33(Y,X,Z,Q,TT,S: in Scalar) return Scalar;
  function G2(Y,X,W,TT,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;
  function G3(Y,X,W,TT,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;
  function U(Y,X,W,TT,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;
  function NewS2(Y,X,W,Q,TT,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;
  function NewS3(Y,X,W,Q,TT,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;
  function NewSS(Y,X,W,Q,TT,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;
  function NewS(N: in Integer; Y,X,TT,S: in Scalar; Eps: in Scalar:=Scal(Zero)) return Scalar;

  -------------------------------------------------
  procedure W(Theta,Y,X: in Scalar; S1,S2: out Scalar; Eps: in Scalar:=Scal(Zero));
  procedure PhiW(Theta,Y,X: in Scalar; S1,S2: out Scalar; Eps: in Scalar:=Scal(Zero));
  procedure P(Theta,Y,X: in Scalar; A1,B1,Y1,A2,B2,Y2: out Scalar; Eps: in Scalar:=Scal(Zero));
  procedure PP(A1,B1,Z1,Z2: in  Scalar; Y: out Scalar);
  procedure U2(Theta,Y,X,T,S: in Scalar; A1,B1,Y1,A2,B2,Y2: out Scalar; Eps: in Scalar:=Scal(Zero));
  procedure U3(Theta,Y,X,T,S: in Scalar; A1,B1,Y1,A2,B2,Y2: out Scalar; Eps: in Scalar:=Scal(Zero));
  procedure V2(Theta,Y,X,T,S: in Scalar; A1,B1,Y1,A2,B2,Y2: out Scalar; Eps: in Scalar:=Scal(Zero));
  procedure V3(Theta,Y,X,T,S: in Scalar; A1,B1,Y1,A2,B2,Y2: out Scalar; Eps: in Scalar:=Scal(Zero));
  procedure H2(A,B,Y: in  out Scalar; Lamb,T,S: in Scalar);
  procedure H3(A,B,Y: in  out Scalar; Lamb,T,S: in Scalar);
  procedure M(Y: in Scalar; Z1,Z2: in out Scalar);
  procedure Nbound(Y,X: in Scalar; Z1,Z2: in out Scalar; Eps: in Scalar:=Scal(Zero) );
  function ArcCos(Z: in Scalar) return Scalar;

private


   R1: constant Scalar:=Scal(0.23);
   L1: constant Scalar:=Scal(-1.23);
--   R2: constant  Scalar:=Scal( 1.6381519569051457);
--   L2: constant  Scalar:=Scal(-1.6381519569051457);
--   R3: constant  Scalar:=Scal(1.6430508944378159);
--   L3: constant  Scalar:=Scal(-1.6430508944378159);
--   R2: constant  Scalar:=Scal( 1.63825);
--   L2: constant  Scalar:=Scal(-1.63825);
   R2: constant  Scalar:=Scal( 1.63825);
   L2: constant  Scalar:=Scal(-1.63825);
   R3: constant  Scalar:=Scal( 1.6430509);
   L3: constant  Scalar:=Scal(-1.6430509);


   Kappa1: constant Scalar:=Scal(0.4000);
   --Kappa2: constant Scalar:=Scal(0.3394670362);
   --Kappa3: constant Scalar:=Scal(0.338393);
   Kappa2: constant Scalar:=Scal(0.339466);
   --   Kappa3: constant Scalar:=Scal(0.33839);
   Kappa3: constant Scalar:=Scal(0.33835);

   C4: constant Scalar:=Scal(Half);
   C3: constant Scalar:=Scal(Zero);

   Lambda0: constant Scalar:=Scal(-0.399535280523135);
   Es: constant      Scalar:=Scal(2.2366548836233370);
   Te: constant      Scalar:=Scal(1.9143106093312106);
   P2: constant Scalar:=Scal(0.16);
   -- P3: constant Scalar:=Scal(0.35);
   P3: constant Scalar:=Scal(3.5);

   ----------------------------------------------

   ScalZero:  constant Scalar := Scal(Zero);
   ScalOne:  constant Scalar := Scal(One);
   ScalTwo:  constant Scalar := Scal(Two);
   ScalHalf:  constant Scalar := Scal(Half);
   ScalPi:  constant Scalar := Scal(3.14159265358979323846,3.14159265358979323847);
   Trunc: constant Boolean := IsNumeric(ScalZero);

   package Vec is new Vectors (Scalar => Scalar, Zero_Scalar => ScalZero);
   package Vec_Num is new Vec.Num;
   use Vec, Vec_Num;

   package TV is new Vectors(Scalar => Taylor, Zero_Scalar => ZeroFun(Radius'Last));

   subtype TayVector is TV.Vector;
   subtype TayMatrix is TV.Matrix;

--   function DD(N: Integer) return Integer;
--   procedure PrepNewt(N: in Integer; R: in Radius; A: in Scalar; Lambda: in out Scalar; S: in  Taylor; Z: in out Taylor; D: out Matrix; V: out Vector);
   --D is derivative of R(S)-S, and V is the vector S-R(S) in the symmetric basis.
   --Everything truncated to order N

end Doubling;
