with Reps, Messages,Reps.IO;
use Reps, Messages,Reps.IO;
with  Ada.Text_IO,Ada.Float_Text_IO;
use  Ada.Text_IO,Ada.Float_Text_IO;
--with S_Numerics, S_Numerics.IO;
--use S_Numerics, S_Numerics.IO;
with S_Intervals, S_Intervals.IO;
use S_Intervals, S_Intervals.IO;
with Scalars, Scalars.IO;
with Doubling;

procedure Feigenbaum_Pert is

   subtype Scalar is Interval;
   --subtype Scalar is Numeric;

   package Numbers is new Scalars (Scalar => Scalar);
   package Numbers_IO is new Numbers.IO;
   use Numbers,Numbers_IO;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   PDeg: constant Natural :=20;
   CutOff: constant Natural :=20;

   package Double is new Doubling (PDeg => PDeg,CutOff => CutOff,  Numbers => Numbers, Numbers_IO => Numbers_IO);
   use Double,Double.Tay,Double.Tay_IO;

   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;

   II1,II2: Integer;
   CC,LM,LP,LL,LDelt,T23,SS,SSDelt,TT,TTDelt,Te1,Es1,L_1,R_1,Tmin,Tmax,Smax,Smin,Tm,Tp,Sm,Sp,Lamb,S1,S2,Theta,TDelt,Pii,Pii2,A1,B1,Y1,A2,B2,Y2,Cen1,RR1,Cen2,RR2,AA12,BB12,YY12,AA22,BB22,YY22,Cenn12,RRR12,Cenn22,RRR22,AA13,BB13,YY13,AA23,BB23,YY23,Cenn13,RRR13,Cenn23,RRR23: Scalar;
   Thet1,Thet2,ThDelt1,ThDelt2,SX1,SY1,SX2,SY2,SSX1,SSY1,SSX2,SSY2,CC1,CC2,CCC12,CCC22,CCC13,CCC23,ZZ1,ZZ2,AAA1,BBB1,Kappa_1,Kappa_2,Kappa_3,Thetta,AAAA1,BBBB1,AAA_2,BBB_2,Thet_2,RR_2,YY_2,Cen_2,ThDelt_2,SX_2,SY_2,AAA_22,BBB_22,YYY_22,SSXX_2,SSYY_2,Tee,Ess,Y_D2,Cen_D2,R_D2,Y_D3,Cen_D3,R_D3,Lambd,SSX12,SSY12,SSX22,SSY22,SSX13,SSY13,SSX23,SSY23: Scalar;
   AAA_1,BBB_1,AAA_12,BBB_12,YYY_12, AAA_13,BBB_13,YYY_13, AAA_23,BBB_23,YYY_23,RR_1,Cen_1,RRR_12,RRR_13,Cennn_12,Cennn_13,RRR_22,Cennn_22,Cennn_23,RRR_23: Scalar;Thet_1,ThDelt_1,SX_1,SY_1,SSX_12,SSY_12,SSX_13,SSY_13,SSX_22,SSX_23,SSY_22,SSY_23,SSXX_12,SSYY_12,SSXX_1,SSYY_1,SSXX_22,SSYY_22,SSXX_23, SSYY_23,YY_1,SSXX_13,SSYY_13,Theta_D2,Theta_D3,NTee,TT2,TT3,TT2Delt,TT3Delt: Scalar;
   RC: Rep;

   N,N1,N2,N3,N4,N5,N6: Integer;
   Approxim,Verb,Verbo: Boolean;

   UName: String:="Output_Files/u_bounds";
   LName: String:="Output_Files/l_bounds";
   UName2: String:="Output_Files/u_bounds_2";
   LName2: String:="Output_Files/l_bounds_2";
   UName3: String:="Output_Files/u_bounds_3";
   LName3: String:="Output_Files/l_bounds_3";

   Z2Name: String:="Output_Files/z2_boundary";
   Z3Name: String:="Output_Files/z3_boundary";
   C2Name: String:="Output_Files/c2_boundary";
   C3Name: String:="Output_Files/c3_boundary";
   PtName: String:="Output_Files/f_point";
   HName: String:="Output_Files/h_boundary";
   VName: String:="Output_Files/v_boundary";

   WName: String:="Output_Files/w_boundary";
   PName_1: String:="Output_Files/p_nbhds_1";
   PName_2: String:="Output_Files/p_nbhds_2";


   U2PName_1: String:="Output_Files/u2p_nbhds_1";
   U2PName_2: String:="Output_Files/u2p_nbhds_2";
   U3PName_1: String:="Output_Files/u3p_nbhds_1";
   U3PName_2: String:="Output_Files/u3p_nbhds_2";


   NName_1: String:="Output_Files/n_nbhds_1";
   NName_2: String:="Output_Files/n_nbhds_2";
   NName_Int: String:="Output_Files/n_nbhds_int";

   HName_1: String:="Output_Files/h_nbhds_1";
   HName_2: String:="Output_Files/h_nbhds_2";

   U2HName_1: String:="Output_Files/u2h_cover_1";
   U2HName_2: String:="Output_Files/u2h_cover_2";

   U3HName_1: String:="Output_Files/u3h_cover_1";
   U3HName_2: String:="Output_Files/u3h_cover_2";

   XiName_1: String:="Output_Files/xi_cover_1";
   XiName_2: String:="Output_Files/xi_cover_2";

   D2Name: String:="Output_Files/d2_nbhd";
   D3Name: String:="Output_Files/d3_nbhd";

   F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,F12,F13,F14,F15,F16,F17,F18: File_Type;
begin
   Verb:=False;
   Verbo:=False;
   Approxim:=True;

   Lamb:=Scal(-0.399535280523135);
   Es1:=Scal(2.2366548836233370);
   Te1:=Scal(1.9143106093312106);
   R_1:=Scal(0.23);
   L_1:=Scal(-1.23);
   RC:=Rep(13.0);

   Kappa_1:=Scal(0.4000);
   Kappa_2:=Scal(0.339466);
   Kappa_3:=Scal(0.33835);

   Pii:=Scal(3.14159265358979323846,3.14159265358979323847);
   Pii2:=Half*Scal(3.14159265358979323846,3.14159265358979323847);

   Tmin:=(Te1-Scal(0.0004));

   New_Line;
   Put("CONSTRUCTING THE SET OF REALIZABLE VALUES of (u'(0),u'(-1/2)");

   New_Line;
   Put("Intersection of Z2 and Z3:");
   New_Line;
   Put("s_min=");Show(Zed2(Corner23));
   Put("s*-s_min=");Show(Es1-Zed2(Corner23));
   T23:=Corner23;
   Smin:=Scal(Inf(Zed2(Corner23)));


   New_Line;
   Put("Intersection of C2 and Z2:");
   New_Line;
   Tmax:=Scal(Sup(Corner33));
   Put("t_max=");Show(Tmax);
   Put("t_max-t*=");Show(Tmax-Te1);
   Smax:=Scal(Sup(Cee2(Tmax)));

   -------------------------

   if  Inf(Tmax) <Inf(Te1) or Sup(Smin)>Inf(Es1) then
      New_Line;
      Put("Warning (t*,s*) is not in tilde{S}");
   end if;

   New_Line;
   Put("Drawing the set tilde{S}...");
   Create(F1,Out_File,Z2Name);
   Create(F2,Out_File,Z3Name);
   Create(F3,Out_File,C2Name);
   Create(F4,Out_File,PtName);
   Create(F5,Out_File,C3Name);
   Create(F6,Out_File,VName);

   N:=2000;
   Tm:=Tmin;
   Tp:=Tmax;
   Sm:=Smin;
   Sp:=Cee2(Tmin);
   TT:=Tm; TTDelt:=(Tp-Tm)/Scal(N);
   TT2:=T23; TT2Delt:=(Tp-T23)/Scal(N);
   TT3:=Tm;  TT3Delt:=(T23-Tm)/Scal(N);
   SS:=Zed3(Tmin);
   SSDelt:=(Sp-SS)/Scal(N);
   --   goto SKK;
   for I in 1..N-1 loop
      Txt_Put(F1,Approx(TT2) );
      Put(F1,"  ");
      Txt_Put(F1,Approx(Zed2(TT2)));
      New_Line(F1);
      Txt_Put(F2,Approx(TT3) );
      Put(F2,"  ");
      Txt_Put(F2,Approx(Zed3(TT3)));
      New_Line(F2);
      Txt_Put(F3,Approx(TT) );
      Put(F3,"  ");
      Txt_Put(F3,Approx(Cee2(TT)));
      New_Line(F3);

      Txt_Put(F5,Approx(TT) );
      Put(F5,"  ");
      Txt_Put(F5,Approx(Cee3(TT)));
      New_Line(F5);

      Txt_Put(F4,Approx(Te1) );
      Put(F4,"  ");
      Txt_Put(F4,Approx(Es1));
      New_Line(F4);

      Txt_Put(F6,Approx(Tmin) );
      Put(F6,"  ");
      Txt_Put(F6,Approx(SS));
      New_Line(F6);

      TT:=Scal(Sup(Scal(Sup(Scal(Sup(TT),Sup(TT+TTDelt))))));
      TT2:=Scal(Sup(Scal(Sup(Scal(Sup(TT2),Sup(TT2+TT2Delt))))));
      TT3:=Scal(Sup(Scal(Sup(Scal(Sup(TT3),Sup(TT3+TT3Delt))))));
      SS:=Scal(Sup(Scal(Sup(SS),Sup(SS+SSDelt))));
   end loop;
   <<SKK>> null;
       Close(F6);
       Close(F5);
       Close(F4);
       Close(F3);
       Close(F2);
       Close(F1);
       Put("done");



       New_Line;
       Put("Checking the invariance of the set tilde{S}, T(t_min,s)>t_min...");
       N:=200;
       SS:=Scal(Inf(Zed3(Tmin)));SSDelt:=Scal(Sup((Sp-SS)/Scal(N)));
       TT:=Tmin;
       --  goto SKKK;
       for I in 1..N loop
          LM:=L_M(Tmin,Center(SS));
          LP:=L_P(Tmin,Center(SS));
          LL:=LM;
          LDelt:=(LP-LM)/Scal(N);
          for J in 1..N loop
             CC:=NewT(Scal(One),Center(LL),Tmin,Center(SS))-Tmin;
             if Inf(CC)<Zero then
                Put("Warning, no invariance:"); Show(CC,False);Put("  ");
                New_Line;
             end if;
             LL:=Scal(Sup(LL),Sup(LL+LDelt));
          end loop;
          SS:=Scal(Sup(SS),Sup(SS+SSDelt));
       end loop;
       Put("done");

       <<SKKK>> null;
           -----------------------------------------------

           New_Line;
           New_Line;
           Put("CHECKING CONTAINMENTS OF VARIOUS SETS...");

           N1:=20;
           N2:=20;
           N3:=20;
           N4:=50;
           N5:=8000;
           N6:=400;

           Theta_D2:=Half*(Pii-Pii*Kappa_2);
           Theta_D3:=Half*(Pii-Pii*Kappa_3);
           TTDelt:=(Tmax-Tmin) / Scal(N1);

           Tee:=Tmin;
           if Approxim then
              Tee:=Scal(Sup(Tee+TTDelt));
           else
              Tee:=Scal(Inf(Tee),Sup(Tee+TTDelt));
           end if;
           for JJJJ in 1..N1-1 loop
              SSDelt:=( Cee2(Center(Tee))-Scal(Rep'Max(Inf(Zed2(Center(Tee))),Inf(Zed3(Center(Tee))))) )/Scal(N2);
              Ess:=Scal(Inf(Cee2(Center(Tee))));
              if Approxim then
                 Ess:=Scal(Inf(Ess-SSDelt));
              else
                 Ess:=Scal(Inf(Ess-SSDelt),Sup(Ess));
              end if;

              for IIII in 1..N2-1 loop
                 New_Line;
                 New_Line;
                 Put("t=");Show(Tee,False);
                 --Put("; delta t=");Show(TTDelt);
                 Put("; s=");Show(Ess);
                 --Put("; delta s=");Show(SSDelt);

                 Create(F1,Out_File,WName);
                 Create(F2,Out_File,PName_1);
                 Create(F3,Out_File,PName_2);
                 Create(F4,Out_File,NName_1);
                 Create(F5,Out_File,NName_2);
                 Create(F6,Out_File,NName_Int);
                 Create(F7,Out_File,HName_1);
                 Create(F10,Out_File,HName_2);
                 Create(F8,Out_File,U2HName_1);
                 Create(F13,Out_File,U3HName_1);
                 Create(F11,Out_File,U2HName_2);
                 Create(F14,Out_File,U3HName_2);
                 Create(F9,Out_File, XiName_1);
                 Create(F12,Out_File,XiName_2);

                 Create(F15,Out_File,U2PName_1);
                 Create(F16,Out_File,U2PName_2);
                 Create(F17,Out_File,U3PName_1);
                 Create(F18,Out_File,U3PName_2);

                 Lambd:=L_M(Center(Tee),Center(Ess));
                 LDelt:=( L_P(Center(Tee),Center(Ess))-Lambd )/Scal(N3);
                 if Approxim then
                    Lambd:=Scal(Sup(Lambd+LDelt));
                 else
                    Lambd:=Scal( Inf(Lambd),Sup(Lambd+LDelt) );
                 end if;

                 for JJJ in 1..N3-1 loop
                    New_Line;
                    Put("lambda=");Show(Lambd);
                    --Put("; delta lambda=");Show(LDelt);
                    NTee:=NewT(Scal(One),Lambd,Tee,Ess);
                    Cen_D2:=Half*(RI2(NTee,Ess)+LI2(NTee,Ess));
                    R_D2:=abs(Half*(LI2(NTee,Ess)-RI2(NTee,Ess)));
                    Y_D2:=-abs(Sin(Theta_D2)*R_D2/Cos(Theta_D2));
                    R_D2:=Sqrt(Sqr(R_D2)+Sqr(Y_D2));
                    Cen_D3:=Half*(RI3(NTee,Ess)+LI3(NTee,Ess));
                    R_D3:=abs(Half*(LI3(NTee,Ess)-RI3(NTee,Ess)));
                    Y_D3:=-abs(Sin(Theta_D3)*R_D3/Cos(Theta_D3));
                    R_D3:=Sqrt(Sqr(R_D3)+Sqr(Y_D3));

                    if Verbo then
                       New_Line;
                       Put("R_2^2=");Show(Sqr(R_D2));
                       Put("R_3^2=");Show(Sqr(R_D3));
                    end if;
                    Theta:=Half*(Pii-Pii*Kappa_1);
                    Thetta:=Theta;
                    TDelt:=Scal(Sup( (Pii2-Theta) / Scal(N4) ));
                    Theta:=Pii2;
                    if Approxim then
                       Theta:=Scal(Sup(Theta+TDelt));
                    else
                       Theta:=Scal(Inf(Theta),(Sup(Theta+TDelt)));
                    end if;
                    W(Thetta,Scal(One),Lambd,S1,S2);
                    AAA1:=Scal(Sup(Upp2(S1,Center(Tee),Center(Ess))));
                    AAA1:=Scal(Sup(Phi1(T(Scal(One),Lambd,Scal(Zero),-Sqrt(Scal(One)-AAA1)))));
                    BBB1:=-AAA1;
                    AAAA1:=AAA1;
                    BBBB1:=BBB1;

                    for I in 1..N4-1 loop
                       PhiW(Theta,Scal(One),Lambd,S1,S2);
                       Txt_Put(F1,Approx(S1));
                       Put(F1,"  ");
                       Txt_Put(F1,Approx(S2));
                       New_Line(F1);

                       Txt_Put(F1,Approx(S1));
                       Put(F1,"  ");
                       Txt_Put(F1,Approx(-S2));
                       New_Line(F1);
                       if I>1 and I<N4-1 then
                          P(Theta,Scal(One),Lambd,A1,B1,Y1,A2,B2,Y2);
                          A1:=Scal(Inf(A1));
                          B1:=Scal(Sup(B1));
                          Y1:=Scal(Inf(Y1));
                          A2:=Scal(Inf(A2));
                          B2:=Scal(Sup(B2));
                          Y2:=Scal(Inf(Y2));


                          U2(Theta,Scal(One),Lambd,Center(Tee),Center(Ess),AA12,BB12,YY12,AA22,BB22,YY22);
                          AA12:=Scal(Inf(AA12));
                          BB12:=Scal(Sup(BB12));
                          YY12:=Scal(Inf(YY12));
                          AA22:=Scal(Inf(AA22));
                          BB22:=Scal(Sup(BB22));
                          YY22:=Scal(Inf(YY22));

                          U3(Theta,Scal(One),Lambd,Center(Tee),Center(Ess),AA13,BB13,YY13,AA23,BB23,YY23);
                          AA13:=Scal(Inf(AA13));
                          BB13:=Scal(Sup(BB13));
                          YY13:=Scal(Inf(YY13));
                          AA23:=Scal(Inf(AA23));
                          BB23:=Scal(Sup(BB23));
                          YY23:=Scal(Inf(YY23));

                          -----------------------------------------------
                          RRR12:=Sqrt( Sqr(Half*(AA12-BB12))+Sqr(YY12) );
                          Cenn12:=Half*(AA12+BB12);
                          RRR22:=Sqrt( Sqr(Half*(AA22-BB22))+Sqr(YY22) );
                          Cenn22:=Half*(AA22+BB22);
                          -----------------------------------------------
                          RRR13:=Sqrt( Sqr(Half*(AA13-BB13))+Sqr(YY13) );
                          Cenn13:=Half*(AA13+BB13);
                          RRR23:=Sqrt( Sqr(Half*(AA23-BB23))+Sqr(YY23) );
                          Cenn23:=Half*(AA23+BB23);
                          -----------------------------------------------
                          RR1:=Sqrt( Sqr(Half*(A1-B1))+Sqr(Y1) );
                          Cen1:=Half*(A1+B1);
                          Thet1:=(ArcCos((abs(Half*(A1-B1)) / RR1 ) ));
                          if Inf(Y1)>Zero then
                             Thet1:=-Thet1;
                          end if;
                          ThDelt1:=Scal(Sup((Pii-Two*Thet1)/Scal(N5)));
                          -----------------------------------------------
                          RR2:=Sqrt( Sqr(Half*(A2-B2))+Sqr(Y2) );
                          Cen2:=Half*(A2+B2);
                          Thet2:=(ArcCos((abs(Half*(A2-B2)) / RR2 )) );
                          if Inf(Y2)>Zero then
                             Thet2:=-Thet2;
                          end if;
                          ThDelt2:=Scal(Sup((Pii-Two*Thet2)/Scal(N5)));
                          if Approxim then
                             Thet2:=Scal(Sup(Thet2+ThDelt2));
                             Thet1:=Scal(Sup(Thet1+ThDelt1));
                          else
                             Thet2:=Scal(Inf(Thet2),(Sup(Thet2+ThDelt2)));
                             Thet1:=Scal(Inf(Thet1),(Sup(Thet1+ThDelt1)));
                          end if;
                          -----------------------------------------------
                          II1:=0;II2:=0;

                          for J in 1..N5-1 loop

                             SX1:=Cen1 + Cos((Thet1))*RR1;
                             SY1:=Y1   + Sin((Thet1))*RR1;
                             SSX12:=Cenn12 + Cos((Thet1))*RRR12;
                             SSY12:=YY12   + Sin((Thet1))*RRR12;
                             SSX13:=Cenn13 + Cos((Thet1))*RRR13;
                             SSY13:=YY13   + Sin((Thet1))*RRR13;

                             SX2:=Cen2 + Cos((Thet2))*RR2;
                             SY2:=Y2   + Sin((Thet2))*RR2;
                             SSX22:=Cenn22 + Cos((Thet2))*RRR22;
                             SSY22:=YY22   + Sin((Thet2))*RRR22;
                             SSX23:=Cenn23 + Cos((Thet2))*RRR23;
                             SSY23:=YY23   + Sin((Thet2))*RRR23;
                             CC1:=Half*(Sqr(RR1)-Sqr(RR2)-Sqr(Cen1)-Sqr(Y1)+Sqr(Cen2)+Sqr(Y2)-Two*SY1*(Y2-Y1))/(Cen2-Cen1);

                             CC2:=Half*(Sqr(RR1)-Sqr(RR2)-Sqr(Cen1)-Sqr(Y1)+Sqr(Cen2)+Sqr(Y2)-Two*SY2*(Y2-Y1))/(Cen2-Cen1);

                             CCC12:=Half*(Sqr(RRR12)-Sqr(RRR22)-Sqr(Cenn12)-Sqr(YY12)+Sqr(Cenn22)+Sqr(YY22)-Two*SSY12*(YY22-YY12))/(Cenn22-Cenn12);
                             CCC13:=Half*(Sqr(RRR13)-Sqr(RRR23)-Sqr(Cenn13)-Sqr(YY13)+Sqr(Cenn23)+Sqr(YY23)-Two*SSY13*(YY23-YY13))/(Cenn23-Cenn13);
                             CCC22:=Half*(Sqr(RRR12)-Sqr(RRR22)-Sqr(Cenn12)-Sqr(YY12)+Sqr(Cenn22)+Sqr(YY22)-Two*SSY22*(YY22-YY12))/(Cenn22-Cenn12);
                             CCC23:=Half*(Sqr(RRR13)-Sqr(RRR23)-Sqr(Cenn13)-Sqr(YY13)+Sqr(Cenn23)+Sqr(YY23)-Two*SSY23*(YY23-YY13))/(Cenn23-Cenn13);
                             if Approx(SX1)>Approx(CC1) then
                                Txt_Put(F2,Approx(SX1));
                                Put(F2,"  ");
                                Txt_Put(F2,Approx(SY1));
                                New_Line(F2);
                                Txt_Put(F2,Approx(SX1));
                                Put(F2,"  ");
                                Txt_Put(F2,Approx(-SY1));
                                New_Line(F2);
                             elsif Approx(SX2)<Approx(CC2) then
                                Txt_Put(F3,Approx(SX2));
                                Put(F3,"  ");
                                Txt_Put(F3,Approx(SY2));
                                New_Line(F3);
                                Txt_Put(F3,Approx(SX2));
                                Put(F3,"  ");
                                Txt_Put(F3,Approx(-SY2));
                                New_Line(F3);
                             end if;
                             -----------------------------------------------
                             Txt_Put(F15,Approx(SSX12));
                             Put(F15,"  ");
                             Txt_Put(F15,Approx(SSY12));
                             New_Line(F15);
                             Txt_Put(F15,Approx(SSX12));
                             Put(F15,"  ");
                             Txt_Put(F15,Approx(-SSY12));
                             New_Line(F15);

                             Txt_Put(F17,Approx(SSX13));
                             Put(F17,"  ");
                             Txt_Put(F17,Approx(SSY13));
                             New_Line(F17);
                             Txt_Put(F17,Approx(SSX13));
                             Put(F17,"  ");
                             Txt_Put(F17,Approx(-SSY13));
                             New_Line(F17);

                             Txt_Put(F16,Approx(SSX22));
                             Put(F16,"  ");
                             Txt_Put(F16,Approx(SSY22));
                             New_Line(F16);
                             Txt_Put(F16,Approx(SSX22));
                             Put(F16,"  ");
                             Txt_Put(F16,Approx(-SSY22));
                             New_Line(F16);

                             Txt_Put(F18,Approx(SSX23));
                             Put(F18,"  ");
                             Txt_Put(F18,Approx(SSY23));
                             New_Line(F18);
                             Txt_Put(F18,Approx(SSX23));
                             Put(F18,"  ");
                             Txt_Put(F18,Approx(-SSY23));
                             New_Line(F18);
                             -----------------------------------------------
                             if Approx(SSX12)>Approx(CCC12) or  Approx(SSX13)>Approx(CCC13)  then
                                Theta2(SSX12,SSY12,Center(Tee),Center(Ess));
                                Theta3(SSX13,SSY13,Center(Tee),Center(Ess));
                                if Sup(Sqr(SSX12-Theta2(Cenn12,Center(Tee),Center(Ess)))+Sqr(SSY12))< Sup(Sqr(SSX13-Theta3(Cenn13,Center(Tee),Center(Ess)))+Sqr(SSY13)) then
                                   SSX1:=SSX12;
                                   SSY1:=SSY12;
                                else
                                   SSX1:=SSX13;
                                   SSY1:=SSY13;
                                end if;

                                Nbound(Scal(One),Lambd,SSX1,SSY1);

                                Txt_Put(F4,Approx(SSX1));
                                Put(F4,"  ");
                                Txt_Put(F4,Approx(-SSY1));
                                New_Line(F4);

                                Txt_Put(F4,Approx(-SSX1));
                                Put(F4,"  ");
                                Txt_Put(F4,Approx(-SSY1));
                                New_Line(F4);
                                II1:=1;
                                ZZ1:=(SSX1);
                                ZZ2:=(SSY1);

                             elsif Approx(SSX22)<Approx(CCC22) or Approx(SSX23)<Approx(CCC23) then

                                Theta2(SSX22,SSY22,Center(Tee),Center(Ess));
                                Theta3(SSX23,SSY23,Center(Tee),Center(Ess));

                                if Sup(Sqr(SSX22-Theta2(Cenn22,Center(Tee),Center(Ess)))+Sqr(SSY22))< Sup(Sqr(SSX23-Theta3(Cenn23,Center(Tee),Center(Ess)))+Sqr(SSY23)) then
                                   SSX2:=SSX22;
                                   SSY2:=SSY22;
                                else
                                   SSX2:=SSX23;
                                   SSY2:=SSY23;
                                end if;

                                Nbound(Scal(One),Lambd,SSX2,SSY2);

                                Txt_Put(F5,Approx(SSX2));
                                Put(F5,"  ");
                                Txt_Put(F5,Approx(-SSY2));
                                New_Line(F5);
                                Txt_Put(F5,Approx(-SSX2));
                                Put(F5,"  ");
                                Txt_Put(F5,Approx(-SSY2));
                                New_Line(F5);
                                II2:=1;
                                ZZ1:=(SSX2);
                                ZZ2:=(SSY2);
                             end if;
                             -----------------------------------------------
                             if II1=II2 then

                                Txt_Put(F6,Approx(ZZ1));
                                Put(F6,"  ");
                                Txt_Put(F6,Approx(-ZZ2));
                                New_Line(F6);

                                Txt_Put(F6,Approx(-ZZ1));
                                Put(F6,"  ");
                                Txt_Put(F6,Approx(-ZZ2));
                                New_Line(F6);
                                II1:=0;

                                --goto SKIP;
                                AAA_1:=(Half*(ZZ1+AAAA1));
                                BBB_1:=-AAA_1;
                                AAA_2:=(Half*(ZZ1-AAAA1));
                                BBB_2:=Scal(One-(1.0E-8));
                                PP(AAA_1,BBB_1,ZZ1,ZZ2,YY_1);
                                PP(AAA_2,BBB_2,ZZ1,ZZ2,YY_2);
                                AAA_1:=Scal(Inf(AAA_1));
                                BBB_1:=Scal(Sup(BBB_1));
                                AAA_2:=Scal(Inf(AAA_2));
                                BBB_2:=Scal(Sup(BBB_2));
                                AAA_12:=AAA_1;
                                BBB_12:=BBB_1;
                                YYY_12:=YY_1;
                                AAA_13:=AAA_1;
                                BBB_13:=BBB_1;
                                YYY_13:=YY_1;

                                AAA_22:=AAA_2;
                                BBB_22:=BBB_2;
                                YYY_22:=YY_2;
                                AAA_23:=AAA_2;
                                BBB_23:=BBB_2;
                                YYY_23:=YY_2;
                                H2(AAA_12,BBB_12,YYY_12,Lambd,Center(Tee),Center(Ess));
                                H2(AAA_22,BBB_22,YYY_22,Lambd,Center(Tee),Center(Ess));
                                H3(AAA_13,BBB_13,YYY_13,Lambd,Center(Tee),Center(Ess));
                                H3(AAA_23,BBB_23,YYY_23,Lambd,Center(Tee),Center(Ess));
                                --Put("HERE19");
                                RR_1:=Sqrt( Sqr(Half*(AAA_1-BBB_1) )+ Sqr(YY_1) );
                                Cen_1:=Scal(Zero);
                                RR_2:=Sqrt( Sqr(Half*(AAA_2-BBB_2) )+ Sqr(YY_2));
                                Cen_2:=Half*(AAA_2+BBB_2);

                                RRR_12:=Sqrt( Sqr(Half*(AAA_12-BBB_12) )+ Sqr(YYY_12) );
                                Cennn_12:=Half*(BBB_12+AAA_12);

                                RRR_13:=Sqrt( Sqr(Half*(AAA_13-BBB_13) )+ Sqr(YYY_13) );
                                Cennn_13:=Half*(BBB_13+AAA_13);

                                RRR_22:=Sqrt( Sqr(Half*(AAA_22-BBB_22) )+ Sqr(YYY_22) );
                                Cennn_22:=Half*(BBB_22+AAA_22);

                                RRR_23:=Sqrt( Sqr(Half*(AAA_23-BBB_23) )+ Sqr(YYY_23) );
                                Cennn_23:=Half*(BBB_23+AAA_23);

                                Thet_1:=ArcCos((abs(Half*(AAA_1-BBB_1)) / RR_1 ) ) ;
                                Thet_2:=ArcCos((abs(Half*(AAA_2-BBB_2)) / RR_2 ) ) ;

                                if Inf(YY_1)>Zero then
                                   Thet_1:=-Thet_1;
                                end if;
                                if Inf(YY_2)>Zero then
                                   Thet_2:=-Thet_2;
                                end if;

                                ThDelt_1:=Scal(Sup((Pii-Two*Thet_1)/Scal(N6)));
                                ThDelt_2:=Scal(Sup((Pii-Two*Thet_2)/Scal(N6)));
                                if Approxim then
                                   Thet_2:=Scal(Sup(Thet_2+ThDelt_2));
                                   Thet_1:=Scal(Sup(Thet_1+ThDelt_1));
                                else
                                   Thet_2:=Scal(Inf(Thet_2),(Sup(Thet_2+ThDelt_2)));
                                   Thet_1:=Scal(Inf(Thet_1),(Sup(Thet_1+ThDelt_1)));
                                end if;
                                --Put("HERE20");
                                -----------------------------------------------
                                for JJ in 1..N6-1 loop
                                   SX_1:=Cen_1+ Cos((Thet_1))*RR_1;
                                   SY_1:=YY_1 + Sin((Thet_1))*RR_1;
                                   SX_2:=Cen_2+ Cos((Thet_2))*RR_2;
                                   SY_2:=YY_2 + Sin((Thet_2))*RR_2;
                                   -----------------------------------------------
                                   SSX_12:=Cennn_12+ Cos((Thet_1))*RRR_12;
                                   SSY_12:=YYY_12  + Sin((Thet_1))*RRR_12;
                                   SSX_13:=Cennn_13+ Cos((Thet_1))*RRR_13;
                                   SSY_13:=YYY_13  + Sin((Thet_1))*RRR_13;
                                   -----------------------------------------------
                                   SSX_22:=Cennn_22+ Cos((Thet_2))*RRR_22;
                                   SSY_22:=YYY_22  + Sin((Thet_2))*RRR_22;
                                   SSX_23:=Cennn_23+ Cos((Thet_2))*RRR_23;
                                   SSY_23:=YYY_23  + Sin((Thet_2))*RRR_23;
                                   -----------------------------------------------

                                   if Approx(SX_1)>Approx(ZZ1) then
                                      Txt_Put(F7,Approx(SX_1));
                                      Put(F7,"  ");
                                      Txt_Put(F7,Approx(-SY_1));
                                      New_Line(F7);

                                      Txt_Put(F7,Approx(-SX_1));
                                      Put(F7,"  ");
                                      Txt_Put(F7,Approx(-SY_1));
                                      New_Line(F7);

                                      Txt_Put(F8,Approx(SSX_12));
                                      Put(F8,"  ");
                                      Txt_Put(F8,Approx(SSY_12));
                                      New_Line(F8);
                                      Txt_Put(F13,Approx(SSX_13));
                                      Put(F13,"  ");
                                      Txt_Put(F13,Approx(SSY_13));
                                      New_Line(F13);

                                      SSXX_12:=SSX_12;
                                      SSYY_12:=SSY_12;
                                      SSXX_13:=SSX_13;
                                      SSYY_13:=SSY_13;

                                      Theta2(SSXX_12,SSYY_12,Tee,Ess);
                                      Theta3(SSXX_13,SSYY_13,Tee,Ess);
                                      if Sup(Sqr(SSXX_12)+Sqr(SSYY_12))<Sup(Sqr(SSXX_13)+Sqr(SSYY_13)) then
                                         SSXX_1:=-SSXX_12/Lambd;
                                         SSYY_1:=-SSYY_12/Lambd;
                                      else
                                         SSXX_1:=-SSXX_13/Lambd;
                                         SSYY_1:=-SSYY_13/Lambd;
                                      end if;
                                      -----------------------------------------------
                                      if Verb then
                                         if Inf(Sqr(R_D2))<Sup( Sqr(SSXX_1-Cen_D2)+Sqr(SSYY_1-Y_D2) )  and  Sup( Sqr(SSXX_1-Cen_D2)+Sqr(SSYY_1-Y_D2) )<RC  then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE LEFT OUTSIDE OF D2");
                                            Show( Sqr(SSXX_1-Cen_D2)+Sqr(SSYY_1-Y_D2 ),False);Put(">");Show(Scal(Inf(Sqr(R_D2))));
                                         elsif  Inf(Sqr(R_D2))<Sup( Sqr(-SSXX_1-Cen_D2)+Sqr(SSYY_1-Y_D2) )  and  Sup( Sqr(SSXX_1-Cen_D2)+Sqr(SSYY_1-Y_D2) )<RC  then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE RIGHT OUTSIDE OF D2");
                                            Show( Sqr(-SSXX_1-Cen_D2)+Sqr(SSYY_1-Y_D2 ),False);Put(">");Show(Scal(Inf(Sqr(R_D2))));
                                         end if;

                                         if Inf(Sqr(R_D3))<Sup(Sqr(SSXX_1-Cen_D3)+Sqr(SSYY_1-Y_D3) )  and  Sup( Sqr(SSXX_1-Cen_D3)+Sqr(SSYY_1-Y_D3) )<RC  then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE LEFT  OUTSIDE OF D3");
                                            Show( Sqr(SSXX_1-Cen_D3)+Sqr(SSYY_1-Y_D3),False);Put(">");Show(Scal(Inf(Sqr(R_D3))));
                                         elsif  Inf(Sqr(R_D3))<Sup(Sqr(-SSXX_1-Cen_D3)+Sqr(SSYY_1-Y_D3) ) and  Sup( Sqr(SSXX_1-Cen_D3)+Sqr(SSYY_1-Y_D3) )<RC then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE RIGHT OUTSIDE OF D3");
                                            Show( Sqr(-SSXX_1-Cen_D3)+Sqr(SSYY_1-Y_D3),False);Put(">");Show(Scal(Inf(Sqr(R_D3))));
                                         end if;
                                      end if;
                                      -----------------------------------------------

                                      Txt_Put(F9,Approx(SSXX_1));
                                      Put(F9,"  ");
                                      Txt_Put(F9,Approx(SSYY_1));
                                      New_Line(F9);

                                      Txt_Put(F9,Approx(-SSXX_1));
                                      Put(F9,"  ");
                                      Txt_Put(F9,Approx(SSYY_1));
                                      New_Line(F9);

                                   end if;
                                   -----------------------------------------------
                                   if Approx(SX_2)<Approx(ZZ1) then
                                      Txt_Put(F10,Approx(SX_2));
                                      Put(F10,"  ");
                                      Txt_Put(F10,Approx(-SY_2));
                                      New_Line(F10);

                                      Txt_Put(F10,Approx(-SX_2));
                                      Put(F10,"  ");
                                      Txt_Put(F10,Approx(-SY_2));
                                      New_Line(F10);

                                      Txt_Put(F11,Approx(SSX_22));
                                      Put(F11,"  ");
                                      Txt_Put(F11,Approx(SSY_22));
                                      New_Line(F11);
                                      Txt_Put(F14,Approx(SSX_23));
                                      Put(F14,"  ");
                                      Txt_Put(F14,Approx(SSY_23));
                                      New_Line(F14);

                                      SSXX_22:=SSX_22;
                                      SSYY_22:=SSY_22;
                                      SSXX_23:=SSX_23;
                                      SSYY_23:=SSY_23;
                                      Theta2(SSXX_22,SSYY_22,Tee,Ess);
                                      Theta3(SSXX_23,SSYY_23,Tee,Ess);
                                      if Sup(Sqr(SSXX_22)+Sqr(SSYY_22))<Sup(Sqr(SSXX_23)+Sqr(SSYY_23)) then
                                         SSXX_2:=-SSXX_22/Lambd;
                                         SSYY_2:=-SSYY_22/Lambd;
                                      else
                                         SSXX_2:=-SSXX_23/Lambd;
                                         SSYY_2:=-SSYY_23/Lambd;
                                      end if;
                                      -----------------------------------------------
                                      if Verb then
                                         if Inf(Sqr(R_D2))<Sup( Sqr(SSXX_2-Cen_D2)+Sqr(SSYY_2-Y_D2) ) and  Sup( Sqr(SSXX_2-Cen_D2)+Sqr(SSYY_2-Y_D2) )<RC  then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE LEFT OUTSIDE OF D2");
                                            Show( Sqr(SSXX_2-Cen_D2)+Sqr(SSYY_2-Y_D2 ),False);Put(">");Show(Scal(Inf(Sqr(R_D2))));
                                         elsif  Inf(Sqr(R_D2))<Sup( Sqr(-SSXX_2-Cen_D2)+Sqr(SSYY_2-Y_D2) ) and  Sup( Sqr(SSXX_2-Cen_D2)+Sqr(SSYY_2-Y_D2) )<RC  then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE RIGHT  OUTSIDE OF D2");
                                            Show(  Sqr(-SSXX_2-Cen_D2)+Sqr(SSYY_2-Y_D2 ),False);Put(">");Show(Scal(Inf(Sqr(R_D2))));
                                         end if;

                                         if Inf(Sqr(R_D3))<Sup(Sqr(SSXX_2-Cen_D3)+Sqr(SSYY_2-Y_D3) ) and  Sup( Sqr(SSXX_2-Cen_D3)+Sqr(SSYY_2-Y_D3) )<RC then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE LEFT OUTSIDE OF D3");
                                            Show( Sqr(SSXX_2-Cen_D3)+Sqr(SSYY_2-Y_D3 ),False);Put(">");Show(Scal(Inf(Sqr(R_D3))));
                                         elsif  Inf(Sqr(R_D3))<Sup(Sqr(-SSXX_2-Cen_D3)+Sqr(SSYY_2-Y_D3) ) and  Sup( Sqr(SSXX_2-Cen_D3)+Sqr(SSYY_2-Y_D3) )<RC then
                                            New_Line;
                                            Put("WARNING: A POINT ON THE RIGHT OUTSIDE OF D3");
                                            Show(  Sqr(-SSXX_2-Cen_D3)+Sqr(SSYY_2-Y_D3),False);Put(">");Show(Scal(Inf(Sqr(R_D3))));
                                         end if;
                                      end if;
                                      -----------------------------------------------
                                      Txt_Put(F12,Approx(SSXX_2));
                                      Put(F12,"  ");
                                      Txt_Put(F12,Approx(SSYY_2));
                                      New_Line(F12);

                                      Txt_Put(F12,Approx(-SSXX_2));
                                      Put(F12,"  ");
                                      Txt_Put(F12,Approx(SSYY_2));
                                      New_Line(F12);
                                   end if;

                                   if Approxim then
                                      Thet_1:=Scal(Sup(Scal(Sup(Thet_1),(Sup(Thet_1+ThDelt_1)))));
                                      Thet_2:=Scal(Sup(Scal(Sup(Thet_2),(Sup(Thet_2+ThDelt_2)))));
                                   else
                                      Thet_1:=Scal(Sup(Thet_1),Sup(Thet_1+ThDelt_1));
                                      Thet_2:=Scal(Sup(Thet_2),Sup(Thet_2+ThDelt_2));
                                   end if;
                                end loop;

                                <<SKIP>> null;
                             end if;

                             if Approxim then
                                Thet1:=Scal(Sup(Scal(Sup(Thet1),(Sup(Thet1+ThDelt1)))));
                                Thet2:=Scal(Sup(Scal(Sup(Thet2),(Sup(Thet2+ThDelt2)))));
                             else
                                Thet1:=Scal(Sup(Thet1),Sup(Thet1+ThDelt1));
                                Thet2:=Scal(Sup(Thet2),Sup(Thet2+ThDelt2));
                             end if;
                          end loop;
                       end if;

                       <<SKIPP>> null;
                           if Approxim then
                              Theta:=Scal(Sup(Scal(Sup(Theta),(Sup(Theta+TDelt)))));
                           else
                              Theta:=Scal(Sup(Theta),(Sup(Theta+TDelt)));
                           end if;
                    end loop;
                    if Approxim then
                       Lambd:=Scal(Sup(Scal(Sup(Lambd),Sup(Lambd+LDelt))));
                    else
                       Lambd:=Scal(Sup(Lambd),Sup(Lambd+LDelt));
                    end if;
                 end loop;

                 Close(F18);
                 Close(F17);
                 Close(F16);
                 Close(F15);
                 Close(F14);
                 Close(F13);
                 Close(F12);
                 Close(F11);
                 Close(F10);
                 Close(F9);
                 Close(F8);
                 Close(F7);
                 Close(F6);
                 Close(F5);
                 Close(F4);
                 Close(F3);
                 Close(F2);
                 Close(F1);
                 if Approxim then
                    Ess:=Scal(Inf(Scal(Inf(Ess-SSDelt),Inf(Ess))));
                 else
                    Ess:=Scal(Inf(Ess-SSDelt),Inf(Ess));
                 end if;
              end loop;
              if Approxim then
                 Tee:=Scal(Sup(Scal(Sup(Tee),Sup(Tee+TTDelt))));
              else
                 Tee:=Scal(Sup(Tee),Sup(Tee+TTDelt));
              end if;
           end loop;

           New_Line;
           Put("...DONE");

           return;

end Feigenbaum_Pert;





