with Ada.Numerics.Generic_Elementary_Functions;

pragma Elaborate_All(Ada.Numerics.Generic_Elementary_Functions);

package body Reps.Ops is

  function Sqr(R: Rep) return Rep is
  begin
    return R*R;
  end Sqr;

  function Sign(R: Rep) return Rep is
     Zer: constant:=Rep(0.0);
  begin
     if R>Zer then return Rep(1.0);
     elsif R<Zer then return Rep(-1.0);
     else return Rep(0.0);
     end if;
  end Sign;


  package Rep_EF is new Ada.Numerics.Generic_Elementary_Functions(Rep);

  function Sqrt(R: Rep) return Rep renames Rep_EF.Sqrt;
  function Log(R: Rep) return Rep renames Rep_EF.Log;
  function Exp(R: Rep) return Rep renames Rep_EF.Exp;
  function Cos(R: Rep) return Rep renames Rep_EF.Cos;
  function ArcTan(R: Rep; R1: Rep:=Rep(1.0)) return Rep renames Rep_EF.ArcTan;

end Reps.Ops;
