with Ada.Text_IO;
use Ada.Text_IO;

generic

  with function Scal(K: Integer) return Scalar is <>;
  with function ">"(S1,S2: Scalar) return Boolean is <>;
  with function "<"(S1,S2: Scalar) return Boolean is <>;
  with function ">="(S1,S2: Scalar) return Boolean is <>;
  with function "<="(S1,S2: Scalar) return Boolean is <>;
  with function "abs"(S: Scalar) return Scalar is <>;
  with function "/"(S,T: Scalar) return Scalar is <>;
  with function Sqrt(S: Scalar) return Scalar is <>;
  with procedure Show(S: in Scalar; NewLine: in Boolean := True) is <>;
  with procedure Get(F: in File_Type; S: out Scalar; Decimal: in Boolean := True) is <>;
  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := True) is <>;
package Vectors.Num is

  type Pivot is array(Integer range <>) of Integer;

  function Norm2(B: Vector) return Scalar;
  procedure Decomp(A: in out Matrix; Cond: out Scalar; Pvt: out Pivot; Work: out Vector);
  procedure Solve(A: in Matrix; B: in out Vector; Pvt: in Pivot);
  procedure Eigenvalues(A: in Matrix; Br,Bi: out Vector);
  procedure Eigenvector(A: in Matrix; R: in Scalar; B: out Vector; Eps: in Scalar);

end Vectors.Num;
